<?php

//language select creation
function news_language_select($available_lang,$default, $select_name = "language")
{
  $lang_select = '<select name="' . $select_name . '">';
  foreach ($available_lang as $code => $displayname)
  {
    $selected = ( strtolower($default) == strtolower($code) ) ? ' selected="selected"' : '';
    $lang_select .= '<option value="' . $code . '"' . $selected . '>' . ucwords($displayname) . '</option>';
  }
  
  $lang_select .= '</select>';

  return $lang_select;
}

function display_select_news_wrapper($query, $selecteds, $blockname)
{
  $result = pwg_query($query);
  
  $news = array();
  
  if (!empty($result))
  {
    while ($row = mysql_fetch_array($result))
    {
      array_push($news, $row);
    }
  }
  display_select_news($news, $selecteds, $blockname);
}

function display_select_news($news, $selecteds, $blockname)
{
  global $template;

  foreach ($news as $new)
  {
    $selected = '';
    if (in_array($new['id'], $selecteds))
    {
      $selected = ' selected="selected"';
    }

    $option = '['.$new['new_id'].'] - '.$new['title'];

    $template->assign_block_vars(
      $blockname,
      array('SELECTED'=>$selected,
            'VALUE'=>$new['new_id'],
            'OPTION'=>$option
        ));
  }
}


function calculate_news_permissions($user_id)
{
  global $user;

  $private_array = array();
  $authorized_array = array();
  $refused_array = array();

  $query = '
    SELECT id
    FROM '.NEWS_TABLE.'
    WHERE status = \'private\'
    ;';
  $result = pwg_query($query);

  while ($row = mysql_fetch_array($result))
  {
    array_push($private_array, $row['id']);
  }

  // retrieve news ids directly refused to the user
  $query = '
    SELECT new_id
    FROM '.NEWS_USER_REFUSED_TABLE.'
    WHERE user_id = '.$user_id.'
    ;';
  $refused_array = array_from_query($query, 'new_id');

  // retrieve news ids directly authorized to the user
  $query = '
    SELECT new_id
    FROM '.NEWS_USER_ACCESS_TABLE.'
    WHERE user_id = '.$user_id.'
    ;';
  $authorized_array = array_from_query($query, 'new_id');

  // retrieve news ids refuseded to the groups the user belongs to
  $query = '
    SELECT new_id
    FROM '.NEWS_GROUP_REFUSED_TABLE.' AS ngr
    INNER JOIN '.USER_GROUP_TABLE.' AS ug ON ug.group_id = ngr.group_id
    WHERE ug.user_id = '.$user_id.'
    ;';
  $refused_array = array_unique(array_merge($refused_array, array_from_query($query, 'new_id')));

  // retrieve news ids authorized to the groups the user belongs to
  $query = '
    SELECT new_id
    FROM '.NEWS_GROUP_ACCESS_TABLE.' AS nga
    INNER JOIN '.USER_GROUP_TABLE.' AS ug ON ug.group_id = nga.group_id
    WHERE ug.user_id = '.$user_id.'
    ;';
  $authorized_array = array_unique(array_merge($authorized_array, array_from_query($query, 'new_id')));

  // only unauthorized private + refused categories are forbidden
  $forbidden_array = array_unique(array_merge($refused_array, array_diff($private_array, $authorized_array)));

  if ( empty($forbidden_array) )
  {// at least, the list contains 0 value. This news does not exists so
   // where clauses such as "WHERE news_id NOT IN(0)" will always be
   // true.
    array_push($forbidden_array, 0);
  }

  return implode(',', $forbidden_array);
}

?>
